//
//  ComAccentureXibmodView.m
//  XibModule
//
//  Created by Kothari, Sumit on 18/01/16.
//
//

#import "ComAccentureXibmodView.h"
#import "TiUtils.h"
@implementation ComAccentureXibmodView

- (void)initializeState
{
    // Creates and keeps a reference to the view upon initialization
    myView = [[UIView alloc] initWithFrame:[self frame]];
    UIViewController* RootController = [[UIViewController alloc] initWithNibName:@"modules/com.accenture.xibmod/RootController" bundle:[NSBundle mainBundle]];

    [self addSubview:RootController.view];
    [super initializeState];
}

-(void)dealloc
{
    // Deallocates the view
    RELEASE_TO_NIL(myView);
    [super dealloc];
}

-(void)frameSizeChanged:(CGRect)frame bounds:(CGRect)bounds
{
    // Sets the size and position of the view
    [TiUtils setView:myView positionRect:bounds];
}

-(void)setColor_:(id)color
{
    // Assigns the view's background color
    myView.backgroundColor = [[TiUtils colorValue:color] _color];
}

@end
